/***********************************************************************/
/*                                                                     */
/*  FILE        :ir_remocon.c                                          */
/*  DATE        :Wed, Dec 16, 2009                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	XCb`̕ѕƃ|[gԍ̑Ή
-------------------------------------------------------------------------
	       +-----+                                  +-----+
	       | SW8 |                                  | SW4 |
	       |(P5 )|                                  |(P53)|
	       +-----+                                  +-----+
	+-----+       +-----+                    +-----+       +-----+
	| SW5 |       | SW6 |                    | SW1 |       | SW2 |
	|(P5 )|       |(P5 )|                    |(P50)|       |(P51)|
	+-----+       +-----+                    +-----+       +-----+
	       +-----+                                  +-----+
	       | SW7 |                                  | SW3 |
	       |(P5 )|                                  |(P52)|
	       +-----+                                  +-----+
************************************************************************/

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		//H8L̖߂g
#include	"iodefine.h"	//I/Õx`
#include	"binary.h"		//C2ig߂̒`

/************************************************************************
	萔̒`iڎwj
************************************************************************/
#define		OK			0		//߂l
#define		NG			-1		//߂l

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/
//									  0         1         2         3
//									  0123456789012345678901234567890
const char StartChkCnstData[32]	=	{"TOYO-LINX Co.,Ltd. IR-Send     "};

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// XCb`͂Ɋ֌Wϐ -------------------------------------------
unsigned char	SwData1		=	0;	//t@[Xg[h
unsigned char	SwData2		=	0;	//_u[hɂ茈肵f[^
unsigned char	SwData3		=	0;	//Õ_u[hŌ肵f[^
unsigned char	SwData4		=	0;	//01ɕωf[^
unsigned char	SwStatus	=	0;	//XCb`̓Xe[^X
									// 0:t@[Xg[h
									// 1:_u[h

// X^[gʂɊ֌Wϐ -------------------------------------------
char			StartChkData[32];	//X^[gʃf[^

/************************************************************************
	֐̒`
************************************************************************/
void		button(unsigned char);
void		id_set(void);
void		init_io(void);
void		init_tmv(void);
void		intprog_tmv(void);
void		main(void);
void		switch_in(void);

void		IR_sig_out(char);	//AZu֐̒`

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	// CjVCY ----------------------------------------------------
	init_io();
	init_tmv();

	// C[v -----------------------------------------------------
	while(1){
		if (SwData2!=0){
			button(SwData2);
			SwData4 = 0;
		}
		else{
			IO.PDR6.BYTE = _11111110B;
		}
	}
}

/************************************************************************
	{^/,ŒID
************************************************************************/
void button(unsigned char sw)
{
	IR_sig_out(sw);
}

/************************************************************************
	I/O|[g CjVCY
************************************************************************/
void init_io(void)
{
	IO.PMR5.BYTE	=	0x00;	//|[g5,ėpo̓|[g
	IO.PUCR5.BYTE	=	0xff;	//|[g5,vAbvI
	IO.PCR5			=	0x00;	//|[g5,P50-P57

	IO.PCR6			=	0xff;	//|[g6,P60-P67o
	IO.PDR6.BYTE	=	0xfe;	//|[g6,o͐ݒ
}

/************************************************************************
	^C}V CjVCY
************************************************************************/
void init_tmv(void)
{
	TV.TCSRV.BYTE	=	0x00;	//TOMV[q͎gȂ
	TV.TCORA		=	156;	//=2ms(156/156.25KHz=1ms)
	TV.TCRV1.BYTE	=	0x01;	//TRGVgK͋֎~,
	TV.TCRV0.BYTE	=	0x4b;	//RyA}b`A ݃Cl[u
								//RyA}b`A TCNTVNA
								//NbN/128(20MHz/128=156.25KHz)
}

/************************************************************************
	^C}V (1ms)
************************************************************************/
#pragma regsave (intprog_tmv)
void intprog_tmv(void)
{
	//RyA}b`tOA NA
	TV.TCSRV.BIT.CMFA = 0;

	//XCb`
	switch_in();
}

/************************************************************************
	XCb`
************************************************************************/
void switch_in(void)
{
	unsigned char a;
	
	switch(SwStatus){
		case 0:
			SwData1 = ~IO.PDR5.BYTE;
			if (SwData1!=0)	{SwStatus = 1;}
			else			{SwData2 = SwData3 =0;}
			break;
		case 1:
			a = ~IO.PDR5.BYTE;
			if (SwData1==a){
				SwData2 = SwData1;
				SwData4 = SwData4 | (SwData2 & (~SwData3));
				SwData3 = SwData2;
			}
			SwStatus = 0;
			break;
	}
}
