/***********************************************************************/
/*                                                                     */
/*  FILE        :ir_remocon_robo.c                                     */
/*  DATE        :Thu, Dec 10, 2009                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	
-------------------------------------------------------------------------
2009-12-10 : vOJn
************************************************************************/

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		//H8L̖߂g
#include	"iodefine.h"	//I/Õx`
#include	"binary.h"		//C2ig߂̒`

/************************************************************************
	萔̒`iڎwj
************************************************************************/
#define		OK			0		//߂l
#define		NG			-1		//߂l

//{bg --------------------------------------------------------------
#define		STEP		6		//sp^[Xebv
#define		STEP_MAX	8		//őp^[Xebv
#define		TABLE_MAX	8		//őp^[e[u

#define		SERVO_STEP	128		//T[{[^1V[PXɂڍsiK

//ʐM ------------------------------------------------------------------
#define		RXBUF_SIZE	256		//RxBuf̃TCY

//\tgEFA^C} ----------------------------------------------------
#define		T0Const		1000	//T0(1000ms)	ʐMr₦Ă~܂ł̎ԁiR[hj
#define		T1Const		0		//T1(ms)
#define		T2Const		0		//T2(ms)
#define		T3Const		0		//T3(ms)
#define		T4Const		0		//T4(ms)
#define		T5Const		0		//T5(ms)
#define		T6Const		0		//T6(ms)
#define		T7Const		0		//T7(ms)

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/
// sp^[
const int SequenceTable[TABLE_MAX][STEP_MAX+1][8] = {
//	e[u(0)
	{
//		G						r		EG		E		E		Er
		{6,0,0,0,0,0,0,},												//Xebv
		{0,		150,	-570,	300,	0,		150,	570,	-300},	//step1
		{-125,	150,	-570,	300,	-400,	150,	570,	-300},	//step2
		{-125,	-150,	-570,	300,	-320,	-150,	570,	-300},	//step3
		{0,		-150,	-570,	300,	0,		-150,	570,	-300},	//step4
		{400,	-150,	-570,	300,	125,	-150,	570,	-300},	//step5
		{320,	150,	-570,	300,	125,	150,	570,	-300},	//step6
		{0,		0,		0,		0,		0,		0,		0,		0},		//step7
		{0,		0,		0,		0,		0,		0,		0,		0}		//step8
	},
//	e[u(1)
	{
//		G						r		EG		E		E		Er
		{6,0,0,0,0,0,0,},												//Xebv
		{0,		150,	-570,	300,	0,		150,	570,	-300},	//step1
		{400,	150,	-570,	300,	125,	150,	570,	-300},	//step2
		{320,	-150,	-570,	300,	125,	-150,	570,	-300},	//step3
		{0,		-150,	-570,	300,	0,		-150,	570,	-300},	//step4
		{-125,	-150,	-570,	300,	-400,	-150,	570,	-300},	//step5
		{-125,	150,	-570,	300,	-320,	150,	570,	-300},	//step6
		{0,		0,		0,		0,		0,		0,		0,		0},		//step7
		{0,		0,		0,		0,		0,		0,		0,		0}		//step8
	},
//	e[u(2)
	{
//		G						r		EG		E		E		Er
		{6,0,0,0,0,0,0,},												//Xebv
		{0,		150,	-570,	300,	0,		200,	570,	-300},	//step1
		{-125,	150,	-570,	300,	-400,	200,	570,	-300},	//step2
		{-125,	-150,	-570,	300,	-320,	-200,	570,	-300},	//step3
		{0,		-150,	-570,	300,	0,		-200,	570,	-300},	//step4
		{400,	-150,	-570,	300,	125,	-200,	570,	-300},	//step5
		{320,	150,	-570,	300,	125,	200,	570,	-300},	//step6
		{0,		0,		0,		0,		0,		0,		0,		0},		//step7
		{0,		0,		0,		0,		0,		0,		0,		0}		//step8
	},
//	e[u(3)
	{
//		G						r		EG		E		E		Er
		{6,0,0,0,0,0,0,},												//Xebv
		{0,		200,	-570,	300,	0,		150,	570,	-300},	//step1
		{-125,	200,	-570,	300,	-400,	150,	570,	-300},	//step2
		{-125,	-200,	-570,	300,	-320,	-150,	570,	-300},	//step3
		{0,		-200,	-570,	300,	0,		-150,	570,	-300},	//step4
		{400,	-200,	-570,	300,	125,	-150,	570,	-300},	//step5
		{320,	200,	-570,	300,	125,	150,	570,	-300},	//step6
		{0,		0,		0,		0,		0,		0,		0,		0},		//step7
		{0,		0,		0,		0,		0,		0,		0,		0}		//step8
	},
//	e[u(4)
	{
//		G						r		EG		E		E		Er
		{6,0,0,0,0,0,0,},												//Xebv
		{0,		0,		0,		0,		0,		0,		0,		0},		//step1
		{0,		0,		0,		0,		0,		0,		0,		0},		//step2
		{0,		0,		0,		0,		0,		0,		0,		0},		//step3
		{0,		0,		0,		0,		0,		0,		0,		0},		//step4
		{0,		0,		0,		0,		0,		0,		0,		0},		//step5
		{0,		0,		0,		0,		0,		0,		0,		0},		//step6
		{0,		0,		0,		0,		0,		0,		0,		0},		//step7
		{0,		0,		0,		0,		0,		0,		0,		0}		//step8
	},
//	e[u(5)
	{
//		G						r		EG		E		E		Er
		{6,0,0,0,0,0,0,},												//Xebv
		{0,		0,		0,		0,		0,		0,		0,		0},		//step1
		{0,		0,		0,		0,		0,		0,		0,		0},		//step2
		{0,		0,		0,		0,		0,		0,		0,		0},		//step3
		{0,		0,		0,		0,		0,		0,		0,		0},		//step4
		{0,		0,		0,		0,		0,		0,		0,		0},		//step5
		{0,		0,		0,		0,		0,		0,		0,		0},		//step6
		{0,		0,		0,		0,		0,		0,		0,		0},		//step7
		{0,		0,		0,		0,		0,		0,		0,		0}		//step8
	},
//	e[u(6)
	{
//		G						r		EG		E		E		Er
		{6,0,0,0,0,0,0,},												//Xebv
		{0,		0,		0,		0,		0,		0,		0,		0},		//step1
		{0,		0,		0,		0,		0,		0,		0,		0},		//step2
		{0,		0,		0,		0,		0,		0,		0,		0},		//step3
		{0,		0,		0,		0,		0,		0,		0,		0},		//step4
		{0,		0,		0,		0,		0,		0,		0,		0},		//step5
		{0,		0,		0,		0,		0,		0,		0,		0},		//step6
		{0,		0,		0,		0,		0,		0,		0,		0},		//step7
		{0,		0,		0,		0,		0,		0,		0,		0}		//step8
	},
//	e[u(7)
	{
//		G						r		EG		E		E		Er
		{6,0,0,0,0,0,0,},												//Xebv
		{0,		0,		0,		0,		0,		0,		0,		0},		//step1
		{0,		0,		0,		0,		0,		0,		0,		0},		//step2
		{0,		0,		0,		0,		0,		0,		0,		0},		//step3
		{0,		0,		0,		0,		0,		0,		0,		0},		//step4
		{0,		0,		0,		0,		0,		0,		0,		0},		//step5
		{0,		0,		0,		0,		0,		0,		0,		0},		//step6
		{0,		0,		0,		0,		0,		0,		0,		0},		//step7
		{0,		0,		0,		0,		0,		0,		0,		0}		//step8
	}
};

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// T[{[^̒_iJEglj/_l1500s  200ns = 7500
/*
// M҂̗ PirkusR TYPE-02
unsigned int	HomePos[8]	=	{7400	//P60,G
								,7500	//P61,
								,7350	//P62,
								,7500	//P63,r
								,7250	//P64,EG
								,7650	//P65,E
								,7800	//P66,E
								,7750	//P67,Er
								};
*/
// M҂̗ PirkusR TYPE-02U
unsigned int	HomePos[8]	=	{7500	//P60,G
								,6030	//P61,
								,7600	//P62,
								,7500	//P63,r
								,7500	//P64,EG
								,9050	//P65,E
								,7500	//P66,E
								,7500	//P67,Er
								};

// T[{[^̈ʒuipXC_́}ʕbj
int				ServoPos[8]	=	{0,0,0,0,0,0,0,0};
// T[{[^̌݃JEgl
long			ServoCnt[8];	//16rbg^C}ZɃZbg
// T[{[^̖ڕWJEgl
long			GoalCnt[8];
// T[{[^JEglڍs1iKZl
long			Add1Step[8];
// T[{[^JEglڍsJE^
unsigned int	MoveCnt;
// T[{[^JEglڍs̃V[PX
unsigned char	SequenceStage	=	0;	// 0:~
										// 1:ڍs
										// 2:I

// {bg
unsigned char	StepCnt;
unsigned char	StepCnst;
int				PatternTable	=	-1;
unsigned char	RoboFlag		=	0;

// ʐMɊ֌Wϐ ---------------------------------------------------
unsigned char	RxBuf[RXBUF_SIZE];	//Mobt@
unsigned char	*RxBufWrPnt;		//Mobt@Cg|C^
unsigned char	*RxBufRdPnt;		//Mobt@[h|C^
unsigned char	*RxBufMin;			//Mobt@̍ŏ
unsigned char	*RxBufMax;			//Mobt@̍Ō

// \tgEFA^C}Ɋ֌Wϐ -------------------------------------
struct SoftTimer{					//\tgEFA^C}̍\̃^O
	unsigned char	Status;			//^C}Xe[^X
									// 0:~(^C}gp)
									// 1:X^[gw
									// 2:JEg
									// 3:JEgI
	unsigned long	Count;			//^C}JE^
};
struct SoftTimer TimT0;				//T0^C}
struct SoftTimer TimT1;				//T1^C}
struct SoftTimer TimT2;				//T2^C}
struct SoftTimer TimT3;				//T3^C}
struct SoftTimer TimT4;				//T4^C}
struct SoftTimer TimT5;				//T5^C}
struct SoftTimer TimT6;				//T6^C}
struct SoftTimer TimT7;				//T7^C}

unsigned long	T0 = T0Const;		//T0^C}JE^l
unsigned long	T1 = T1Const;		//T1^C}JE^l
unsigned long	T2 = T2Const;		//T2^C}JE^l
unsigned long	T3 = T3Const;		//T3^C}JE^l
unsigned long	T4 = T4Const;		//T4^C}JE^l
unsigned long	T5 = T5Const;		//T5^C}JE^l
unsigned long	T6 = T6Const;		//T6^C}JE^l
unsigned long	T7 = T7Const;		//T7^C}JE^l

/************************************************************************
	֐̒`
************************************************************************/
void			init_servo(void);
void			init_tmz(void);
void			intprog_tmz0(void);
void			main(void);
void			robocon(void);
void			servo_set(void);
void			wait(void);

void			init_tmb1(void);

int				put_rxbuf(unsigned char);
void			rxerr_sci3_2(void);
void			rxdata_sci3_2(void);
unsigned char	rxone(void);
void			txone(unsigned char);
int				get_rxbuf(unsigned char *);
void			init_rxbuf(void);
void			init_sci3_2(void);
void			intprog_sci3_2(void);

void			init_soft_timer(void);
void			dec_soft_timer(struct SoftTimer *,unsigned long);

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	// CjVCY ----------------------------------------------------
	IO.PCR5 = 0xff;

	init_servo();
	init_tmz();
	init_soft_timer();
	init_tmb1();
	init_rxbuf();
	init_sci3_2();

	// C[v -----------------------------------------------------
	while(1){
		robocon();
	}
}

/************************************************************************
	{bg
************************************************************************/
void robocon(void)
{
	int pat,i,j;
	unsigned char dt;	//RMf[^

	if (get_rxbuf(&dt)==OK){
		TimT0.Status = 0;	//^C}Xgbv
		switch (dt){
			case _00001000B:
				pat = 0;
				break;
			case _00000100B:
				pat = 1;
				break;
			case _00000010B:
				pat = 2;
				break;
			case _00000001B:
				pat = 3;
				break;
			default:
				pat = -1;
				break;
		}
		if ((pat!=-1)&&(pat!=PatternTable)){
			PatternTable = pat;
			StepCnt = 0;
			StepCnst = SequenceTable[PatternTable][0][0];
			RoboFlag = 1;
		}
		TimT0.Status = 1;	//^C}X^[g
	}

	if ((RoboFlag==1)&&(SequenceStage!=1)){
		for (j=0; j<8; j++){
			ServoPos[j] = SequenceTable[PatternTable][StepCnt+1][j];
		}
		servo_set();
		StepCnt = StepCnt + 1;
		if (StepCnt>=StepCnst)	{StepCnt = 0;}
	}

	if (TimT0.Status==3){	//ʐMr₦
		TimT0.Status = 0;	//^C}Xgbv
		PatternTable = -1;
		RoboFlag = 0;	//~
	}

	IO.PDR5.BYTE = StepCnt;
}

/************************************************************************
	T[{[^ CjVCY
************************************************************************/
void init_servo(void)
{
	int i;

	for (i=0; i<8; i++){
		ServoCnt[i] = HomePos[i] * 0x10000;
	}
}

/************************************************************************
	T[{[^f[^Zbg
************************************************************************/
void servo_set(void)
{
	int i;

	for (i=0; i<8; i++){
		GoalCnt[i] = (HomePos[i] + ServoPos[i] * 5) * 0x10000;
		Add1Step[i] = (GoalCnt[i] - ServoCnt[i]) / SERVO_STEP;
	}

	MoveCnt = SERVO_STEP;
	SequenceStage = 1;
}

/************************************************************************
	^C}Z CjVCY
************************************************************************/
void init_tmz(void)
{
	TZ.TSTR.BYTE	=	0x00;	//TCNT0,1 ~

	TZ0.TCR.BYTE	=	0xe2;	//NA,/4
	TZ1.TCR.BYTE	=	0xe2;	//NA,/4

	TZ.TMDR.BYTE	=	0x0f;	//TCNT0,1͓

	TZ.TOCR.BYTE	=	0xff;	//o=1

	TZ.TOER.BYTE	=	0x00;	//o͒[qCl[u

	TZ0.TIORA.BYTE	=	0x99;	//GRA,GRB̓RyA}b`0o
	TZ0.TIORC.BYTE	=	0x99;	//GRC,GRD̓RyA}b`0o
	TZ1.TIORA.BYTE	=	0x99;	//GRA,GRB̓RyA}b`0o
	TZ1.TIORC.BYTE	=	0x99;	//GRC,GRD̓RyA}b`0o

	TZ0.TSR.BYTE	=	0x00;	//݃tONA
	TZ1.TSR.BYTE	=	0x00;	//݃tONA

	TZ0.TIER.BYTE	=	0x10;	//I[o[t[C^[vgCl[u
	TZ1.TIER.BYTE	=	0x00;	//C^vgfBZ[u

	TZ0.GRA			=	HomePos[0];	//JEgl
	TZ0.GRB			=	HomePos[1];	//JEgl
	TZ0.GRC			=	HomePos[2];	//JEgl
	TZ0.GRD			=	HomePos[3];	//JEgl
	TZ1.GRA			=	HomePos[4];	//JEgl
	TZ1.GRB			=	HomePos[5];	//JEgl
	TZ1.GRC			=	HomePos[6];	//JEgl
	TZ1.GRD			=	HomePos[7];	//JEgl

	TZ0.TCNT		=	0x0000;	//TCNT0=0
	TZ1.TCNT		=	0x0000;	//TCNT1=0

	TZ.TSTR.BYTE	=	0x03;	//TCNT0,1 JEgX^[g
}

/************************************************************************
	^C}Z `l0 
************************************************************************/
#pragma regsave (intprog_tmz0)
void intprog_tmz0(void)
{
	int i;

	//^C}Z I[ot[C^[vgtO NA
	TZ0.TSR.BIT.OVF =0;

	//TCNT0,1 ~
	TZ.TSTR.BYTE = 0x00;

	//JEgl̉Z
	if (SequenceStage==1){
		for (i=0; i<8; i++){
			ServoCnt[i] = ServoCnt[i] + Add1Step[i];
		}
		MoveCnt--; if (MoveCnt==0) {SequenceStage = 2;}
	}

	//^C}ZɃJEglZbg
	TZ0.GRA = ServoCnt[0] / 0x10000;
	TZ0.GRB = ServoCnt[1] / 0x10000;
	TZ0.GRC = ServoCnt[2] / 0x10000;
	TZ0.GRD = ServoCnt[3] / 0x10000;
	TZ1.GRA = ServoCnt[4] / 0x10000;
	TZ1.GRB = ServoCnt[5] / 0x10000;
	TZ1.GRC = ServoCnt[6] / 0x10000;
	TZ1.GRD = ServoCnt[7] / 0x10000;

	//o͂1ɂ
	TZ.TOCR.BYTE = 0xff;

	//TCNT0,1 JEgX^[g
	TZ0.TCNT = 0x0000;
	TZ1.TCNT = 0x0000;
	TZ.TSTR.BYTE = 0x03;
}

/************************************************************************
	EFCg(1000ms)
************************************************************************/
void wait(void)
{
	unsigned long i;

	for (i=0;i<3333333;i++){}
}

/************************************************************************
	^C}B1 CjVCY
************************************************************************/
void init_tmb1(void)
{
	TB1.TMB1.BYTE		=	0xf9;	//I[g[hCNbN/2048
	TB1.TLB1			=	0-97;	//=10ms(100Hz)
	IRR2.BIT.IRRTB1		=	0;		//^C}B1ݗvtO NA
	IENR2.BIT.IENTB1	=	1;		//^C}B1ݗvCl[u
}

/************************************************************************
	^C}B1 (10ms)
************************************************************************/
#pragma regsave (intprog_tmb1)
void intprog_tmb1(void)
{
	//^C}B1ݗvtO NA
	IRR2.BIT.IRRTB1 = 0;

	//\tgEFA^C} T0
	if (TimT0.Status==1 || TimT0.Status==2){
		dec_soft_timer(&TimT0,T0/10);
	}
	//\tgEFA^C} T1
	if (TimT1.Status==1 || TimT1.Status==2){
		dec_soft_timer(&TimT1,T1/10);
	}
	//\tgEFA^C} T2
	if (TimT2.Status==1 || TimT2.Status==2){
		dec_soft_timer(&TimT2,T2/10);
	}
	//\tgEFA^C} T3
	if (TimT3.Status==1 || TimT3.Status==2){
		dec_soft_timer(&TimT3,T3/10);
	}
	//\tgEFA^C} T4
	if (TimT4.Status==1 || TimT4.Status==2){
		dec_soft_timer(&TimT4,T4/10);
	}
	//\tgEFA^C} T5
	if (TimT5.Status==1 || TimT5.Status==2){
		dec_soft_timer(&TimT5,T5/10);
	}
	//\tgEFA^C} T6
	if (TimT6.Status==1 || TimT6.Status==2){
		dec_soft_timer(&TimT6,T6/10);
	}
	//\tgEFA^C} T7
	if (TimT7.Status==1 || TimT7.Status==2){
		dec_soft_timer(&TimT7,T7/10);
	}
}

/************************************************************************
	\tgEFA^C}̃fNg
-------------------------------------------------------------------------
			*pst		\tgEFA^C}\̂̃|C^
			initial		^C}JE^̏l
************************************************************************/
void dec_soft_timer(struct SoftTimer *pst,unsigned long initial)
{
	if (pst->Status==1){			//^C}X^[gw
		pst->Status	=	2;			//JEgZbg
		pst->Count	=	initial;	//^C}JE^
	}
	pst->Count--;	//JE^-1
	if (pst->Count==0)				//JE^0ɂȂ
		pst->Status	=	3;			//JEgIZbg
}

/************************************************************************
	\tgEFA^C}̃CjVCY
************************************************************************/
void init_soft_timer(void)
{
	TimT0.Status = 0; TimT1.Status = 0; TimT2.Status = 0; TimT3.Status = 0;
	TimT4.Status = 0; TimT5.Status = 0; TimT6.Status = 0; TimT7.Status = 0;
}

/************************************************************************
	RxBuf ̏
************************************************************************/
void init_rxbuf(void)
{
	RxBufRdPnt	=	RxBuf;				//Mobt@[h|C^Zbg
	RxBufWrPnt	=	RxBufRdPnt;			//Mobt@Cg|C^Zbg
	RxBufMin	=	RxBuf;				//Mobt@̍ŏZbg
	RxBufMax	=	RxBuf+RXBUF_SIZE-1;	//Mobt@̍ŌZbg
}

/************************************************************************
	RxBuf Ƀf[^i[
-------------------------------------------------------------------------
			data		RxBufɊi[f[^
-------------------------------------------------------------------------
	߂l	OK			i[ł
			NG			G[,obt@炠ӂꂽ
************************************************************************/
int put_rxbuf(unsigned char data)
{
	int ret_code;	//OK or NG

	if ((RxBufRdPnt==RxBufMin && RxBufWrPnt==RxBufMax) || RxBufWrPnt==RxBufRdPnt-1)
		ret_code = NG;		//obt@TCYz
	else{
		*RxBufWrPnt = data;
		RxBufWrPnt++;
		if (RxBufWrPnt>RxBufMax)
			RxBufWrPnt=RxBufMin;	//Cg|C^擪ɖ߂
		ret_code = OK;
	}
	return ret_code;
}

/************************************************************************
	RxBuf f[^o
-------------------------------------------------------------------------
			*pd			of[^Zbg|C^
-------------------------------------------------------------------------
	߂l	OK			o
			NG			G[,obt@ɉĂȂ
************************************************************************/
int get_rxbuf(unsigned char *pd)
{
	int ret_code;

	if (RxBufWrPnt==RxBufRdPnt)
		ret_code = NG;		//obt@ɉĂȂ
	else{
		*pd = *RxBufRdPnt;
		RxBufRdPnt++;
		if (RxBufRdPnt>RxBufMax)
			RxBufRdPnt=RxBufMin;	//[h|C^擪ɖ߂
		ret_code = OK;
	}
	return ret_code;
}

/************************************************************************
	SCI3_2 CjVCY
************************************************************************/
void init_sci3_2(void)
{
	#define		MHz		20			// Clock=20MHz
	#define		BAUD	38400		// BaudRate
	#define		BITR	(MHz*1000000)/BAUD/32-1
	#define		WAIT_1B	(MHz*1000000)/6/BAUD

	unsigned	long	i;

//	IO.PMR1.BIT.TXD2	=	1;			//TxD_2[qCl[u
	SCI3_2.SCR3.BYTE	=	0x00;		//~
	SCI3_2.SMR .BYTE	=	0x00;		//,8bit,NonParity,StopBit=1
	SCI3_2.BRR			=	BITR;		//ޯڰ
	for	(i=0;i<WAIT_1B;i++){};			//1bit wait
	SCI3_2.SCR3.BYTE	=	0x50;		//MCl[u,M荞݃Cl[u
}

/************************************************************************
	SCI3_2 ݁iݗvɂĐU蕪j
************************************************************************/
#pragma regsave (intprog_sci3_2)
void intprog_sci3_2(void)
{
	if (SCI3_2.SSR.BIT.OER==1
	 || SCI3_2.SSR.BIT.FER==1
	 || SCI3_2.SSR.BIT.PER==1)			rxerr_sci3_2();		//MG[
	else if (SCI3_2.SSR.BIT.RDRF==1)	rxdata_sci3_2();	//M
//	else if (SCI3_2.SSR.BIT.TEND==1)	txend_sci3_2();		//MI
//	else if (SCI3_2.SSR.BIT.TDRE==1)	txdata_sci3_2();	//M
}

/************************************************************************
	SCI3_2 MG[
************************************************************************/
void rxerr_sci3_2(void)
{
	unsigned char dmy;

	SCI3_2.SSR.BYTE = SCI3_2.SSR.BYTE & 0x87;	//G[tONA
	dmy = SCI3_2.RDR;							//_~[[h
}

/************************************************************************
	SCI3_2 M
************************************************************************/
void rxdata_sci3_2(void)
{
	put_rxbuf(SCI3_2.RDR);	//f[^RxBufɃXgA
}

/************************************************************************
	SCI3_2 1Mi|[Oj
-------------------------------------------------------------------------
		txdata		Mf[^
************************************************************************/
void txone(unsigned char txdata)
{
	while(SCI3_2.SSR.BIT.TDRE == 0){}		//M\܂ő҂
	SCI3_2.TDR = txdata;
}

/************************************************************************
	SCI3_2 1Mi|[Oj
-------------------------------------------------------------------------
	߂l	Mf[^
************************************************************************/
unsigned char rxone(void)
{
	while(SCI3_2.SSR.BIT.RDRF == 0){}		//M܂ő҂
	return SCI3_2.RDR;
}
