/***********************************************************************/
/*                                                                     */
/*  FILE        :pclink.c                                              */
/*  DATE        :Fri, Mar 03, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	
-------------------------------------------------------------------------
2006-03-03 : vOJn
2007-03-06 : EEPROMɃL[t[f[^XgA
             P17=High->[VGfB^œ
             P17=Low ->XgAL[t[f[^œ
2007-10-12 : {[[g57600{[ɕύX
             o[Wf[^ύX
               #JSR-SDK (RE001 V0.97b)  #Pirkus_R_SDK (RE001 V1.09d)
************************************************************************/

/************************************************************************
	OQƐ錾
************************************************************************/
extern unsigned char	EX_EEPR_FLAG;
extern unsigned char	EX_EEPR_DATA;
extern unsigned int		EX_EEPR_ADDR;
extern unsigned char 	*EX_SQDT_ADDR;
extern unsigned int		EX_SQDT_SIZE;

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		//H8L̖߂g
#include	"iodefine.h"	//I/Õx`

/************************************************************************
	萔̒`iڎwj
************************************************************************/
#define		OK			0		//߂l
#define		NG			-1		//߂l

//PCLINK-----------------------------------------------------------------
#define		p_FNC		0		// t@NVœǂ
#define		p_VOID		1		// Ȃ
#define		p_2D		2		// 2Digit
#define		p_4D		3		// 4Digit
#define		p_2D2D		4		// 2Digit,2Digit
#define		p_2D4D		5		// 2Digit,4Digit
#define		p_2D2D2D	6		// 2Digit,2Digit,2Digit

#define		SERVO_MAX_INDEX		8	//T[{[^̐
#define		KEY_FRAME_MAX_INDEX	20	//L[t[̐

#define		NO_ERROR	(0)
#define		NO_ERROR2	0xff

#define		ERR_NULL					1
#define		ERR_SERVO_INDEX_OVER		2
#define		ERR_SERVO_MIN				3
#define		ERR_SERVO_ORG				4
#define		ERR_SERVO_MAX				5

// PCLINK W[ŎgpĂ
#define		ERR_PARAM1_MISS				10
#define		ERR_PARAM2_MISS				11
#define		ERR_PARAM3_MISS				12
#define		ERR_PARAM4_MISS				13
#define		ERR_PARAM5_MISS				14
#define		ERR_PARAM6_MISS				15

#define		ERR_PARAM1_C_MISS			40
#define		ERR_PARAM2_C_MISS			41
#define		ERR_PARAM3_C_MISS			42
#define		ERR_PARAM4_C_MISS			43
#define		ERR_PARAM5_C_MISS			44
#define		ERR_PARAM6_C_MISS			45

// KEY_FRAME W[Ŏgpwr
#define		ERR_KEYFRAME							100
#define		ERR_KEYFRAME_INDEX_OUTOF_REANGE			101

// MOTION_LIST W[Ŏgpwr
#define		ERR_MOTIONLIST_INDEX_OUTOF_REANGE		210	
#define		ERR_MOTIONLIST_EMPTY_FLAME				211	
#define		ERR_MOTIONLIST_CRC						212	
#define		ERR_MOTIONLIST_HEADER					213	
#define		ERR_MOTIONLIST							214	

//ʐM ------------------------------------------------------------------
#define		RXBUF_SIZE	256		//RxBuf̃TCY
#define		CMD_SIZE	128		//MR}h̍őTCY

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/
//PCLINK̃R}hXg
struct pclink_command_list{
	unsigned char	sig1;			//R}hVOl`-1
	unsigned char	sig2;			//R}hVOl`-2
	unsigned char	input_format;	//R}htH[}bg
	unsigned char	len;			//R}h
};

const struct pclink_command_list g_PCLinkCommandList[] = {
	{'s','a',p_2D4D,10},		//T[{̐Ίpxw
	{'s','n',p_2D,5},			//T[{݂̌̊pxMINɂ
	{'s','m',p_2D,5},			//T[{݂̌̊pxMAXɂ
	{'s','o',p_2D,5},			//T[{݂̌̊pxORGɂ
	{'s','r',p_2D4D,10},		//T[{̑Ίpxw
	{'s','?',p_2D,5},			//T[{݂̌̒`PCɕԂ
	{'f','m',p_2D,5},			//L[t[̐Zbg
	{'f','x',p_FNC,55+40+40},	//L[t[PC󂯂
	{'m','p',p_VOID,2},			//RAMɓĂ郂[V̍Đ
//	{'m','x',p_VOID,2},			//[V̒~
	{'m','o',p_4D,7},			//[V̌_ɕA
	{'m','a',p_FNC,57},			//݂̈ʒuX̏ԂɈڍs
	{'!','!',p_VOID,2},			//Cũo[W
	{'!','x',p_2D,5},			//PCLINK̃[v𑱂邩
	{0,0,0,0}					//Gh}[N
};

//EEPROMwb_f[^
const unsigned char EepromHeader[32] = {
	'P','i','r','k','u','s','.','R',
	' ',
	'T','y','p','e','-','0','2',
	'(','c','h','o','b','i',')',
	' ',
	'T','O','Y','O','L','I','N','X'
};

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// T[{[^̒_iJEglj---------------------------------------
unsigned int	HomePos[SERVO_MAX_INDEX]	=	{7400	//P60,G
												,7500	//P61,
												,7350	//P62,
												,7500	//P63,r
												,7250	//P64,EG
												,7650	//P65,E
												,7800	//P66,E
												,7750	//P67,Er
												};
// T[{[^̍őliJEglj------------------------------------
unsigned int	ServoMax[SERVO_MAX_INDEX]	=	{10611	//P60,G
												,10611	//P61,
												,10611	//P62,
												,10611	//P63,r
												,10611	//P64,EG
												,10611	//P65,E
												,10611	//P66,E
												,10611	//P67,Er
												};
// T[{[^̍ŏliJEglj------------------------------------
unsigned int	ServoMin[SERVO_MAX_INDEX]	=	{4389	//P60,G
												,4389	//P61,
												,4389	//P62,
												,4389	//P63,r
												,4389	//P64,EG
												,4389	//P65,E
												,4389	//P66,E
												,4389	//P67,Er
												};
// T[{[^̌݃JEgl------------------------------------------
long			ServoCnt[SERVO_MAX_INDEX];	//16rbg^C}ZɃZbg
// T[{[^̖ڕWJEgl------------------------------------------
long			GoalCnt[SERVO_MAX_INDEX];
// T[{[^JEglڍs1iKZl-----------------------------
long			Add1Step[SERVO_MAX_INDEX];
// T[{[^JEglڍsJE^------------------------------------
unsigned int	MoveCnt;
// T[{[^JEglڍsXebv----------------------------------
unsigned int	ServoStep;
// T[{[^JEglڍs̃V[PX------------------------------
volatile unsigned char	SequenceStage	=	0;	// 0:~
												// 1:ڍs
												// 2:I

// ʐMɊ֌Wϐ ---------------------------------------------------
unsigned char	RxBuf[RXBUF_SIZE];	//Mobt@
unsigned char	*RxBufWrPnt;		//Mobt@Cg|C^
unsigned char	*RxBufRdPnt;		//Mobt@[h|C^
unsigned char	*RxBufMin;			//Mobt@̍ŏ
unsigned char	*RxBufMax;			//Mobt@̍Ō
unsigned char	RxCmd[CMD_SIZE];	//MR}h
unsigned char	RxCmdStage;			//R}hMXe[W
unsigned char	RxCmdPnt;			//R}hM|C^
unsigned char	RxCmdFormat;		//R}htH[}bg
unsigned char	RxCmdLength;		//R}h̒
unsigned int	CmdParam[4];		//R}hp[^

// PCLINK ---------------------------------------------------------------
struct _key_frame{
	unsigned int	m_nTime;					//̃t[܂ł̎(50=1s)
	unsigned int	m_nReserve;					//U[u
	int				m_Param[SERVO_MAX_INDEX];	//T[{̑Ίpx
};

struct _key_frame KeyFrameTmp;
struct _key_frame KeyFrame[KEY_FRAME_MAX_INDEX];

unsigned char	NumKeyFrame;		//L[t[̐
unsigned char	CntKeyFrame;		//L[t[JE^

/************************************************************************
	֐̒`
************************************************************************/
unsigned char	Cmd_lx_chk(void);
unsigned char	Cmd_sa_chk(void);
unsigned char	Cmd_sm_chk(void);
unsigned char	Cmd_sn_chk(void);
unsigned char	Cmd_so_chk(void);
unsigned char	Cmd_sQ_chk(void);
unsigned char	Cmd_sr_chk(void);
unsigned char	Cmd_fm_chk(void);
unsigned char	Cmd_fx_chk(void);
unsigned char	Cmd_ma_chk(void);
unsigned char	Cmd_mo_chk(void);
int				get_rxbuf(unsigned char *);
void			init_io(void);
void			init_rxbuf(void);
void			init_servo(void);
void			init_sci3(void);
void			init_tmz(void);
void			intprog_sci3(void);
void			intprog_tmz0(void);
void			main(void);
void			PCLINK_CommandWait(void);
int				put_rxbuf(unsigned char);
void			rxerr_sci3(void);
void			rxdata_sci3(void);
unsigned char	rxone(void);
void			send_err(unsigned char,unsigned char,unsigned char);
void			send_ok(void);
void			send_syn(void);
void			servo_set(unsigned int,int *);
void			txone(unsigned char);
void			wait(void);

void			load_eeprom(void);
void			save_eeprom(void);
unsigned int	cal_check_sum(void);

unsigned char	sv_AAngleSet(unsigned int *);
unsigned char	sv_RAngleMin(unsigned int *);
unsigned char	sv_RAngleMax(unsigned int *);
unsigned char	sv_RAngleOrg(unsigned int *);
unsigned char	sv_RAngleSet(unsigned int *);
unsigned char	sv_SendToPC(unsigned int *);
unsigned char	kf_NumOfFrameSet(unsigned int *);
unsigned char	kf_GetFromPC(unsigned int *);
unsigned char	mo_Play(unsigned int *);
unsigned char	mo_Stop(unsigned int *);
unsigned char	mo_MoveToOrigin(unsigned int *);
unsigned char	mo_MoveToX(unsigned int *);
unsigned char	lb_SendToPC(unsigned int *);
unsigned char	lb_LoopSet(unsigned int *);

void			EEPRSQWR(void);
void			EEPRSQRD(void);
void			EEPRCLR(void);
void			EEPRFILL(void);
void			EEPRCHK(void);

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	// CjVCY ----------------------------------------------------
	init_io();
	init_tmz();
	EEPRCHK();
	load_eeprom();
	init_servo();
	init_sci3();
	init_rxbuf();

	// s? --------------------------------------------------------
	if (IO.PDR1.BIT.B7==0){
		while(1){mo_Play(CmdParam);}
	}

	// C[v -----------------------------------------------------
	while(1){
		PCLINK_CommandWait();
	}
}

/************************************************************************
	T[{[^ CjVCY
************************************************************************/
void init_servo(void)
{
	int i;

	for (i=0; i<8; i++){
		ServoCnt[i] = HomePos[i] * 0x10000;
	}
}

/************************************************************************
	[VGfB^̃R}h
************************************************************************/
void PCLINK_CommandWait(void)
{
	unsigned char data;		//RxBufof[^
	unsigned int len;		//R}h
	unsigned char err;
	unsigned int a,b,i,j;

	if (get_rxbuf(&data)==NG) {return;}	//Mf[^Ȃ

	//R}h̎擾-----------------------------------------------------
	switch (RxCmdStage){
		//1Ԗڂ̃f[^..................................................
		case 0:
			for (i=0; g_PCLinkCommandList[i].sig1!=0; i++){
				if (data==g_PCLinkCommandList[i].sig1){
					RxCmd[0] = data;
					RxCmdPnt = 1;
					RxCmdStage = 1;
					return;
				}
			}
			return;
			break;
		//2Ԗڂ̃f[^..................................................
		case 1:
			RxCmd[1] = data;
			for (i=0; g_PCLinkCommandList[i].sig1!=0; i++){
				if ((RxCmd[0]==g_PCLinkCommandList[i].sig1)&&(RxCmd[1]==g_PCLinkCommandList[i].sig2)){
					RxCmdFormat = g_PCLinkCommandList[i].input_format;
					RxCmdLength = g_PCLinkCommandList[i].len - 2;
					RxCmdPnt = 2;
					RxCmdStage = 2;
					break;
				}
			}
			if (RxCmdStage==2){
				if (RxCmdLength==0)	break;
				else				return;
			}
			send_err(0,RxCmd[0],RxCmd[1]);	//o^ĂR}hɂȂ
			RxCmdPnt = 0;
			RxCmdStage = 0;
			return;
			break;
		//3Ԗڈȍ~̃f[^...............................................
		case 2:
			RxCmd[RxCmdPnt] = data; RxCmdPnt++;
			if (data=='-'){
				return;
			}
			else if ((data==',') || ((data>='0') && (data<='9'))){
				RxCmdLength--;
				if ((RxCmd[0]=='f') && (RxCmd[1]=='x')){
					if ((RxCmdLength % 20)==0) {send_syn();}
				}
				if (RxCmdLength!=0) return;
			}
			else{
				RxCmdPnt = 0;
				RxCmdStage = 0;
				return;
			}
			break;
	}
	RxCmdStage = 0;

	//R}hMI----------------------------------------------------
	if		((RxCmd[0]=='s') && (RxCmd[1]=='a')){
		err = Cmd_sa_chk();
		if (err==NO_ERROR) {err = sv_AAngleSet(CmdParam);}
	}

	else if	((RxCmd[0]=='s') && (RxCmd[1]=='n')){
		err = Cmd_sn_chk();
		if (err==NO_ERROR) {err = sv_RAngleMin(CmdParam);}
	}

	else if	((RxCmd[0]=='s') && (RxCmd[1]=='m')){
		err = Cmd_sm_chk();
		if (err==NO_ERROR) {err = sv_RAngleMax(CmdParam);}
	}

	else if	((RxCmd[0]=='s') && (RxCmd[1]=='o')){
		err = Cmd_so_chk();
		if (err==NO_ERROR) {err = sv_RAngleOrg(CmdParam);}
	}

	else if	((RxCmd[0]=='s') && (RxCmd[1]=='r')){
		err = Cmd_sr_chk();
		if (err==NO_ERROR) {err = sv_RAngleSet(CmdParam);}
	}

	else if	((RxCmd[0]=='s') && (RxCmd[1]=='?')){
		err = Cmd_sQ_chk();
		if (err==NO_ERROR) {err = sv_SendToPC(CmdParam);}
	}

	else if	((RxCmd[0]=='f') && (RxCmd[1]=='m')){
		err = Cmd_fm_chk();
		if (err==NO_ERROR) {err = kf_NumOfFrameSet(CmdParam);}
	}

	else if	((RxCmd[0]=='f') && (RxCmd[1]=='x')){
		err = Cmd_fx_chk();
		if (err==NO_ERROR) {err = kf_GetFromPC(CmdParam);}
	}

	else if	((RxCmd[0]=='m') && (RxCmd[1]=='p')){
		err = mo_Play(CmdParam);
	}

//	else if	((RxCmd[0]=='m') && (RxCmd[1]=='x')){
//		err = mo_Stop(CmdParam);
//	}

	else if	((RxCmd[0]=='m') && (RxCmd[1]=='x')){
		err = mo_Stop(CmdParam);
	}

	else if	((RxCmd[0]=='m') && (RxCmd[1]=='o')){
		err = Cmd_mo_chk();
		if (err==NO_ERROR) {err = mo_MoveToOrigin(CmdParam);}
	}

	else if	((RxCmd[0]=='m') && (RxCmd[1]=='a')){
		err = Cmd_ma_chk();
		if (err==NO_ERROR) {err = mo_MoveToX(CmdParam);}
	}

	else if	((RxCmd[0]=='!') && (RxCmd[1]=='!')){
		err = lb_SendToPC(CmdParam);
	}

	else if	((RxCmd[0]=='!') && (RxCmd[1]=='x')){
		err = Cmd_lx_chk();
		if (err==NO_ERROR) {err = lb_LoopSet(CmdParam);}
	}
	else{
		send_err(0,RxCmd[0],RxCmd[1]);	//o^ĂR}hɂȂ
		return;
	}
	
	//[VGfB^ɌʂԂ---------------------------------------
	if      (err==NO_ERROR)	{send_ok();}	//$OKԂ
	else if (err==NO_ERROR2){}				//ł$OKԂĂ
	else					{send_err(err,RxCmd[0],RxCmd[1]);}	//G[
}

/************************************************************************
	sa R}hM`FbN
************************************************************************/
unsigned char Cmd_sa_chk(void)
{
	unsigned int a;

	if (RxCmd[2]!=',') return 1;

	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 10;
	}
	else{
		return 2;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30);
	}
	else{
		return 2;
	}
	CmdParam[0] = a;

	if (RxCmd[5]!=',') return 3;

	if ((RxCmd[6]>='0')&&(RxCmd[6]<='9')){
		a = (RxCmd[6] - 0x30) * 1000;
	}
	else{
		return 4;
	}
	if ((RxCmd[7]>='0')&&(RxCmd[7]<='9')){
		a = a + (RxCmd[7] - 0x30) * 100;
	}
	else{
		return 4;
	}
	if ((RxCmd[8]>='0')&&(RxCmd[8]<='9')){
		a = a + (RxCmd[8] - 0x30) * 10;
	}
	else{
		return 4;
	}
	if ((RxCmd[9]>='0')&&(RxCmd[9]<='9')){
		a = a + (RxCmd[9] - 0x30);
	}
	else{
		return 4;
	}
	CmdParam[1] = a;

	return NO_ERROR;
}

/************************************************************************
	sn R}hM`FbN
************************************************************************/
unsigned char Cmd_sn_chk(void)
{
	unsigned int a;

	if (RxCmd[2]!=',') return 1;

	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 10;
	}
	else{
		return 2;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30);
	}
	else{
		return 2;
	}
	CmdParam[0] = a;

	return NO_ERROR;
}

/************************************************************************
	sm R}hM`FbN
************************************************************************/
unsigned char Cmd_sm_chk(void)
{
	unsigned int a;

	if (RxCmd[2]!=',') return 1;

	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 10;
	}
	else{
		return 2;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30);
	}
	else{
		return 2;
	}
	CmdParam[0] = a;

	return NO_ERROR;
}

/************************************************************************
	so R}hM`FbN
************************************************************************/
unsigned char Cmd_so_chk(void)
{
	unsigned int a;

	if (RxCmd[2]!=',') return 1;

	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 10;
	}
	else{
		return 2;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30);
	}
	else{
		return 2;
	}
	CmdParam[0] = a;

	return NO_ERROR;
}

/************************************************************************
	sr R}hM`FbN
************************************************************************/
unsigned char Cmd_sr_chk(void)
{
	int a;
	unsigned char i,s;

	if (RxCmd[2]!=',') return 1;

	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 10;
	}
	else{
		return 2;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30);
	}
	else{
		return 2;
	}
	CmdParam[0] = a;

	if (RxCmd[5]!=',') return 3;

	i = 6; s = 0;
	if (RxCmd[6]=='-'){
		i++; s = 1;
	}

	if ((RxCmd[i]>='0')&&(RxCmd[i]<='9')){
		a = (RxCmd[i] - 0x30) * 1000;
	}
	else{
		return 4;
	}
	i++;
	if ((RxCmd[i]>='0')&&(RxCmd[i]<='9')){
		a = a + (RxCmd[i] - 0x30) * 100;
	}
	else{
		return 4;
	}
	i++;
	if ((RxCmd[i]>='0')&&(RxCmd[i]<='9')){
		a = a + (RxCmd[i] - 0x30) * 10;
	}
	else{
		return 4;
	}
	i++;
	if ((RxCmd[i]>='0')&&(RxCmd[i]<='9')){
		a = a + (RxCmd[i] - 0x30);
	}
	else{
		return 4;
	}
	if (s==1) {a = 0 - a;}
	CmdParam[1] = a;

	return NO_ERROR;
}

/************************************************************************
	s? R}hM`FbN
************************************************************************/
unsigned char Cmd_sQ_chk(void)
{
	unsigned int a;

	if (RxCmd[2]!=',') return 1;

	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 10;
	}
	else{
		return 2;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30);
	}
	else{
		return 2;
	}
	CmdParam[0] = a;

	return NO_ERROR;
}

/************************************************************************
	fm R}hM`FbN
************************************************************************/
unsigned char Cmd_fm_chk(void)
{
	unsigned int a;

	if (RxCmd[2]!=',') return 1;

	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 10;
	}
	else{
		return 2;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30);
	}
	else{
		return 2;
	}
	CmdParam[0] = a;

	return NO_ERROR;
}

/************************************************************************
	fx R}hM`FbN
************************************************************************/
unsigned char Cmd_fx_chk(void)
{
	int a;
	unsigned char i,s,p;

	if (RxCmd[2]!=',') return 1;

	//KeyFramẽCfbNX
	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 10;
	}
	else{
		return ERR_PARAM2_MISS;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30);
	}
	else{
		return ERR_PARAM2_MISS;
	}
	CmdParam[0] = a;

	if (RxCmd[5]!=',') return ERR_PARAM2_C_MISS;

	//KeyFramem_nTime
	if ((RxCmd[6]>='0')&&(RxCmd[6]<='9')){
		a = (RxCmd[6] - 0x30) * 1000;
	}
	else{
		return ERR_PARAM3_MISS;
	}
	if ((RxCmd[7]>='0')&&(RxCmd[7]<='9')){
		a = a + (RxCmd[7] - 0x30) * 100;
	}
	else{
		return ERR_PARAM3_MISS;
	}
	if ((RxCmd[8]>='0')&&(RxCmd[8]<='9')){
		a = a + (RxCmd[8] - 0x30) * 10;
	}
	else{
		return ERR_PARAM3_MISS;
	}
	if ((RxCmd[9]>='0')&&(RxCmd[9]<='9')){
		a = a + (RxCmd[9] - 0x30);
	}
	else{
		return ERR_PARAM3_MISS;
	}
	KeyFrameTmp.m_nTime = a;

	if (RxCmd[10]!=',') return ERR_PARAM3_C_MISS;

	//KeyFramem_nReserve
	if ((RxCmd[11]>='0')&&(RxCmd[11]<='9')){
		a = (RxCmd[11] - 0x30) * 1000;
	}
	else{
		return ERR_PARAM4_MISS;
	}
	if ((RxCmd[12]>='0')&&(RxCmd[12]<='9')){
		a = a + (RxCmd[12] - 0x30) * 100;
	}
	else{
		return ERR_PARAM4_MISS;
	}
	if ((RxCmd[13]>='0')&&(RxCmd[13]<='9')){
		a = a + (RxCmd[13] - 0x30) * 10;
	}
	else{
		return ERR_PARAM4_MISS;
	}
	if ((RxCmd[14]>='0')&&(RxCmd[14]<='9')){
		a = a + (RxCmd[14] - 0x30);
	}
	else{
		return ERR_PARAM4_MISS;
	}
	KeyFrameTmp.m_nReserve = a;

	//T[{̑Ίpx
	p = 15;
	for (i=0; i<SERVO_MAX_INDEX; i++){
		if (RxCmd[p]!=',') return ERR_PARAM4_C_MISS + i;
		p++;
		s = 0;
		if (RxCmd[p]=='-'){
			p++; s = 1;
		}
		if ((RxCmd[p]>='0')&&(RxCmd[p]<='9')){
			a = (RxCmd[p] - 0x30) * 1000;
		}
		else{
			return ERR_PARAM5_MISS + i;
		}
		p++;
		if ((RxCmd[p]>='0')&&(RxCmd[p]<='9')){
			a = a + (RxCmd[p] - 0x30) * 100;
		}
		else{
			return ERR_PARAM5_MISS + i;
		}
		p++;
		if ((RxCmd[p]>='0')&&(RxCmd[p]<='9')){
			a = a + (RxCmd[p] - 0x30) * 10;
		}
		else{
			return ERR_PARAM5_MISS + i;
		}
		p++;
		if ((RxCmd[p]>='0')&&(RxCmd[p]<='9')){
			a = a + (RxCmd[p] - 0x30);
		}
		else{
			return ERR_PARAM5_MISS + i;
		}
		p++;
		if (s==1) {a = 0 - a;}
		KeyFrameTmp.m_Param[i] = a;
	}
	return NO_ERROR;
}

/************************************************************************
	mo R}hM`FbN
************************************************************************/
unsigned char Cmd_mo_chk(void)
{
	unsigned int a;

	if (RxCmd[2]!=',') return 1;

	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 1000;
	}
	else{
		return 2;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30) * 100;
	}
	else{
		return 2;
	}
	if ((RxCmd[5]>='0')&&(RxCmd[5]<='9')){
		a = a + (RxCmd[5] - 0x30) * 10;
	}
	else{
		return 2;
	}
	if ((RxCmd[6]>='0')&&(RxCmd[6]<='9')){
		a = a + (RxCmd[6] - 0x30);
	}
	else{
		return 2;
	}
	CmdParam[0] = a;

	return NO_ERROR;
}

/************************************************************************
	ma R}hM`FbN
************************************************************************/
unsigned char Cmd_ma_chk(void)
{
	int a;
	unsigned char i,s,p;

	if (RxCmd[2]!=',') return 1;

	//time
	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 1000;
	}
	else{
		return ERR_PARAM2_MISS;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30) * 100;
	}
	else{
		return ERR_PARAM2_MISS;
	}
	if ((RxCmd[5]>='0')&&(RxCmd[5]<='9')){
		a = a + (RxCmd[5] - 0x30) * 10;
	}
	else{
		return ERR_PARAM2_MISS;
	}
	if ((RxCmd[6]>='0')&&(RxCmd[6]<='9')){
		a = a + (RxCmd[6] - 0x30);
	}
	else{
		return ERR_PARAM2_MISS;
	}
	CmdParam[0] = a;

	if (RxCmd[7]!=',') return ERR_PARAM2_C_MISS;

	//KeyFramem_nTime
	if ((RxCmd[8]>='0')&&(RxCmd[8]<='9')){
		a = (RxCmd[8] - 0x30) * 1000;
	}
	else{
		return ERR_PARAM3_MISS;
	}
	if ((RxCmd[9]>='0')&&(RxCmd[9]<='9')){
		a = a + (RxCmd[9] - 0x30) * 100;
	}
	else{
		return ERR_PARAM3_MISS;
	}
	if ((RxCmd[10]>='0')&&(RxCmd[10]<='9')){
		a = a + (RxCmd[10] - 0x30) * 10;
	}
	else{
		return ERR_PARAM3_MISS;
	}
	if ((RxCmd[11]>='0')&&(RxCmd[11]<='9')){
		a = a + (RxCmd[11] - 0x30);
	}
	else{
		return ERR_PARAM3_MISS;
	}
	KeyFrameTmp.m_nTime = a;

	if (RxCmd[12]!=',') return ERR_PARAM3_C_MISS;

	//KeyFramem_nReserve
	if ((RxCmd[13]>='0')&&(RxCmd[13]<='9')){
		a = (RxCmd[13] - 0x30) * 1000;
	}
	else{
		return ERR_PARAM4_MISS;
	}
	if ((RxCmd[14]>='0')&&(RxCmd[14]<='9')){
		a = a + (RxCmd[14] - 0x30) * 100;
	}
	else{
		return ERR_PARAM4_MISS;
	}
	if ((RxCmd[15]>='0')&&(RxCmd[15]<='9')){
		a = a + (RxCmd[15] - 0x30) * 10;
	}
	else{
		return ERR_PARAM4_MISS;
	}
	if ((RxCmd[16]>='0')&&(RxCmd[16]<='9')){
		a = a + (RxCmd[16] - 0x30);
	}
	else{
		return ERR_PARAM4_MISS;
	}
	KeyFrameTmp.m_nReserve = a;

	//T[{̑Ίpx
	p = 17;
	for (i=0; i<SERVO_MAX_INDEX; i++){
		if (RxCmd[p]!=',') return ERR_PARAM4_C_MISS + i;
		p++;
		s = 0;
		if (RxCmd[p]=='-'){
			p++; s = 1;
		}
		if ((RxCmd[p]>='0')&&(RxCmd[p]<='9')){
			a = (RxCmd[p] - 0x30) * 1000;
		}
		else{
			return ERR_PARAM5_MISS + i;
		}
		p++;
		if ((RxCmd[p]>='0')&&(RxCmd[p]<='9')){
			a = a + (RxCmd[p] - 0x30) * 100;
		}
		else{
			return ERR_PARAM5_MISS + i;
		}
		p++;
		if ((RxCmd[p]>='0')&&(RxCmd[p]<='9')){
			a = a + (RxCmd[p] - 0x30) * 10;
		}
		else{
			return ERR_PARAM5_MISS + i;
		}
		p++;
		if ((RxCmd[p]>='0')&&(RxCmd[p]<='9')){
			a = a + (RxCmd[p] - 0x30);
		}
		else{
			return ERR_PARAM5_MISS + i;
		}
		p++;
		if (s==1) {a = 0 - a;}
		KeyFrameTmp.m_Param[i] = a;
	}
	return NO_ERROR;
}

/************************************************************************
	!x R}hM`FbN
************************************************************************/
unsigned char Cmd_lx_chk(void)
{
	unsigned int a;

	if (RxCmd[2]!=',') return 1;

	if ((RxCmd[3]>='0')&&(RxCmd[3]<='9')){
		a = (RxCmd[3] - 0x30) * 10;
	}
	else{
		return 2;
	}
	if ((RxCmd[4]>='0')&&(RxCmd[4]<='9')){
		a = a + (RxCmd[4] - 0x30);
	}
	else{
		return 2;
	}
	CmdParam[0] = a;

	return NO_ERROR;
}

/************************************************************************
	OK𑗐M
************************************************************************/
void send_ok(void)
{
	txone(0x0a);
	txone(0x0d);
	txone('$');
	txone('O');
	txone('K');
	txone(0x0a);
	txone(0x0d);
}

/************************************************************************
	ERR𑗐M
************************************************************************/
void send_err(unsigned char err,unsigned char sig1,unsigned char sig2)
{
	unsigned char err100,err010,err001;

	err100 = err / 100; err = err - err100 * 100;
	err010 = err / 10;  err = err - err010 *  10;
	err001 = err - err010;

	txone(0x0a);
	txone(0x0d);
	txone('$');
	txone('E');
	txone('R');
	txone('R');
	txone(' ');
	txone(err100 | 0x30);
	txone(err010 | 0x30);
	txone(err001 | 0x30);
	txone(':');
	txone('(');
	txone(sig1);
	txone(sig2);
	txone(')');
	txone(0x0a);
	txone(0x0d);
}

/************************************************************************
	SYN𑗐M
************************************************************************/
void send_syn(void)
{
	txone(0x16);
}

/************************************************************************
	T[{̐Ίpxw
************************************************************************/
unsigned char sv_AAngleSet(unsigned int *argv)
{
	long cnt_l;
	int cnt_i;

	if (argv[0]>=SERVO_MAX_INDEX) return ERR_SERVO_INDEX_OVER;
	cnt_l = (40 * (long)argv[1] + 31500) / 9;
	cnt_i = (int)cnt_l;
	ServoCnt[argv[0]] = cnt_i * 0x10000;
	return NO_ERROR;
}

/************************************************************************
	T[{݂̌̊pxMINɎw
************************************************************************/
unsigned char sv_RAngleMin(unsigned int *argv)
{
	if (argv[0]>=SERVO_MAX_INDEX) return ERR_SERVO_INDEX_OVER;
	ServoMin[argv[0]] = ServoCnt[argv[0]] / 0x10000;
	save_eeprom();
	return NO_ERROR;
}

/************************************************************************
	T[{݂̌̊pxMAXɎw
************************************************************************/
unsigned char sv_RAngleMax(unsigned int *argv)
{
	if (argv[0]>=SERVO_MAX_INDEX) return ERR_SERVO_INDEX_OVER;
	ServoMax[argv[0]] = ServoCnt[argv[0]] / 0x10000;
	save_eeprom();
	return NO_ERROR;
}

/************************************************************************
	T[{݂̌̊pxORGɎw
************************************************************************/
unsigned char sv_RAngleOrg(unsigned int *argv)
{
	if (argv[0]>=SERVO_MAX_INDEX) return ERR_SERVO_INDEX_OVER;
	HomePos[argv[0]] = ServoCnt[argv[0]] / 0x10000;
	save_eeprom();
	return NO_ERROR;
}

/************************************************************************
	T[{̑Ίpxw
************************************************************************/
unsigned char sv_RAngleSet(unsigned int *argv)
{
	long cnt_l;
	int cnt_i;

	if (argv[0]>=SERVO_MAX_INDEX) return ERR_SERVO_INDEX_OVER;
	cnt_l = (40 * (long)((int)argv[1])) / 9;
	cnt_i = (int)cnt_l;
	ServoCnt[argv[0]] = (HomePos[argv[0]] + cnt_i) * 0x10000;
	return NO_ERROR;
}

/************************************************************************
	T[{݂̌̒`PCɕԂ
************************************************************************/
unsigned char sv_SendToPC(unsigned int *argv)
{
	long kakudo;
	char d_1000,d_0100,d_0010,d_0001;
	int d;

	if (argv[0]>=SERVO_MAX_INDEX) return ERR_SERVO_INDEX_OVER;

	//wb_[
	txone('#');

	//T[{ԍ
	d_0010 = argv[0] / 10;
	d_0001 = argv[0] - d_0010 * 10;
	txone(d_0010|0x30);
	txone(d_0001|0x30);

	txone(',');

	//](CW,CWW)
	txone('0');
	txone('0');

	txone(',');

	//ORG
	kakudo = (9 * (long)HomePos[argv[0]] - 31500) / 40;
	d = (int)kakudo;
	d_1000 = d / 1000; d = d - d_1000 * 1000;
	d_0100 = d / 100;  d = d - d_0100 *  100;
	d_0010 = d / 10;   d = d - d_0010 *   10;
	d_0001 = d;
	txone(d_1000|0x30);
	txone(d_0100|0x30);
	txone(d_0010|0x30);
	txone(d_0001|0x30);

	txone(',');

	//MIN
	kakudo = (9 * (long)ServoMin[argv[0]] - 31500) / 40;
	d = (int)kakudo;
	d_1000 = d / 1000; d = d - d_1000 * 1000;
	d_0100 = d / 100;  d = d - d_0100 *  100;
	d_0010 = d / 10;   d = d - d_0010 *   10;
	d_0001 = d;
	txone(d_1000|0x30);
	txone(d_0100|0x30);
	txone(d_0010|0x30);
	txone(d_0001|0x30);

	txone(',');

	//MAX
	kakudo = (9 * (long)ServoMax[argv[0]] - 31500) / 40;
	d = (int)kakudo;
	d_1000 = d / 1000; d = d - d_1000 * 1000;
	d_0100 = d / 100;  d = d - d_0100 *  100;
	d_0010 = d / 10;   d = d - d_0010 *   10;
	d_0001 = d;
	txone(d_1000|0x30);
	txone(d_0100|0x30);
	txone(d_0010|0x30);
	txone(d_0001|0x30);

	return NO_ERROR;
}

/************************************************************************
	L[t[̐Zbg
************************************************************************/
unsigned char kf_NumOfFrameSet(unsigned int *argv)
{
	NumKeyFrame = argv[0];
	return NO_ERROR;
}

/************************************************************************
	L[t[PC󂯂
************************************************************************/
unsigned char kf_GetFromPC(unsigned int *argv)
{
	char i;

	KeyFrame[argv[0]].m_nTime = KeyFrameTmp.m_nTime;
	KeyFrame[argv[0]].m_nReserve = KeyFrameTmp.m_nReserve;
	for (i=0; i<SERVO_MAX_INDEX; i++){
		KeyFrame[argv[0]].m_Param[i] = KeyFrameTmp.m_Param[i];
	}
	save_eeprom();
	return NO_ERROR;
}

/************************************************************************
	RAMɓĂ郂[V̍Đ
************************************************************************/
unsigned char mo_Play(unsigned int *argv)
{
	long cnt_l;
	int cnt_i;
	int cnt[SERVO_MAX_INDEX];
	char i,j;

	//L[t[̓o^܂̂Ƃ̓^[
	if (NumKeyFrame==0) return NO_ERROR;

	//$OK炩ߑ
	send_ok();

	//_ɖ߂
	for (i=0; i<SERVO_MAX_INDEX; i++){
		cnt[i] = 0;
	}
	servo_set(50,cnt);	//1bňڍs
	while(SequenceStage<2){}
	SequenceStage = 0;

	//[VĐJn
	for (j=0; j<NumKeyFrame; j++){
		if (KeyFrame[j].m_nTime!=0){
			for (i=0; i<SERVO_MAX_INDEX; i++){
				cnt_l = (40 * (long)((int)KeyFrame[j].m_Param[i])) / 9;
				cnt_i = (int)cnt_l;
				cnt[i] = cnt_i;
			}

			servo_set(KeyFrame[j].m_nTime,cnt);

			while(SequenceStage<2){}
			SequenceStage = 0;
		}
	}
	return NO_ERROR2;
}

/************************************************************************
	[V̒~
************************************************************************/
unsigned char mo_Stop(unsigned int *argv)
{
	return NO_ERROR;
}

/************************************************************************
	[V̌_ɕA
************************************************************************/
unsigned char mo_MoveToOrigin(unsigned int *argv)
{
	int cnt[SERVO_MAX_INDEX];
	char i;

	send_ok();	//炩$OK𑗂

	for (i=0; i<SERVO_MAX_INDEX; i++){
		cnt[i] = 0;
	}

	servo_set(argv[0],cnt);

	while(SequenceStage<2){}
	SequenceStage = 0;

	return NO_ERROR2;
}

/************************************************************************
	݂̈ʒuX̏ԂɈڍs
************************************************************************/
unsigned char mo_MoveToX(unsigned int *argv)
{
	long cnt_l;
	int cnt_i;
	int cnt[SERVO_MAX_INDEX];
	char i;

	send_ok();	//炩$OK𑗂

	for (i=0; i<SERVO_MAX_INDEX; i++){
		cnt_l = (40 * (long)((int)KeyFrameTmp.m_Param[i])) / 9;
		cnt_i = (int)cnt_l;
		cnt[i] = cnt_i;
	}

	servo_set(argv[0],cnt);

	while(SequenceStage<2){}
	SequenceStage = 0;

	return NO_ERROR2;
}

/************************************************************************
	Cũo[W𑗂
************************************************************************/
unsigned char lb_SendToPC(unsigned int *argv)
{
	txone('#');
	txone('P'); txone('i'); txone('r'); txone('k'); txone('u'); txone('s'); txone('_');
	txone('R'); txone('_'); txone('S'); txone('D'); txone('K');
	txone(' ');
	txone('('); txone('R'); txone('E'); txone('0'); txone('0'); txone('1'); txone(' ');
	txone('V'); txone('1'); txone('.'); txone('0'); txone('9'); txone('d'); txone(')');
	return NO_ERROR;

//	txone('#');
//	txone('J'); txone('S'); txone('R'); txone('-'); txone('S'); txone('D'); txone('K');
//	txone(' ');
//	txone('('); txone('E'); txone('0'); txone('0'); txone('1'); txone(' ');
//	txone('V'); txone('0'); txone('.'); txone('9'); txone('7'); txone('b'); txone(')');
//	return NO_ERROR;
}

/************************************************************************
	PCLINK̃[v𑱂邩
************************************************************************/
unsigned char lb_LoopSet(unsigned int *argv)
{
	return NO_ERROR;
}

/************************************************************************
	T[{[^f[^Zbg
************************************************************************/
void servo_set(unsigned int time,int *cnt)
{
	int i;

	ServoStep = (time * 100000) / 65536;

	for (i=0; i<SERVO_MAX_INDEX; i++){
		GoalCnt[i] = (HomePos[i] + cnt[i]) * 0x10000;
		Add1Step[i] = (GoalCnt[i] - ServoCnt[i]) / ServoStep;
	}

	MoveCnt = ServoStep;
	SequenceStage = 1;
}

/************************************************************************
	^C}Z CjVCY
************************************************************************/
void init_tmz(void)
{
	TZ.TSTR.BYTE	=	0x00;	//TCNT0,1 ~

	TZ0.TCR.BYTE	=	0xe2;	//NA,/4
	TZ1.TCR.BYTE	=	0xe2;	//NA,/4

	TZ.TMDR.BYTE	=	0x0f;	//TCNT0,1͓

	TZ.TOCR.BYTE	=	0xff;	//o=1

	TZ.TOER.BYTE	=	0x00;	//o͒[qCl[u

	TZ0.TIORA.BYTE	=	0x99;	//GRA,GRB̓RyA}b`0o
	TZ0.TIORC.BYTE	=	0x99;	//GRC,GRD̓RyA}b`0o
	TZ1.TIORA.BYTE	=	0x99;	//GRA,GRB̓RyA}b`0o
	TZ1.TIORC.BYTE	=	0x99;	//GRC,GRD̓RyA}b`0o

	TZ0.TSR.BYTE	=	0x00;	//݃tONA
	TZ1.TSR.BYTE	=	0x00;	//݃tONA

	TZ0.TIER.BYTE	=	0x10;	//I[o[t[C^[vgCl[u
	TZ1.TIER.BYTE	=	0x00;	//C^vgfBZ[u

	TZ0.GRA			=	HomePos[0];	//JEgl
	TZ0.GRB			=	HomePos[1];	//JEgl
	TZ0.GRC			=	HomePos[2];	//JEgl
	TZ0.GRD			=	HomePos[3];	//JEgl
	TZ1.GRA			=	HomePos[4];	//JEgl
	TZ1.GRB			=	HomePos[5];	//JEgl
	TZ1.GRC			=	HomePos[6];	//JEgl
	TZ1.GRD			=	HomePos[7];	//JEgl

	TZ0.TCNT		=	0x0000;	//TCNT0=0
	TZ1.TCNT		=	0x0000;	//TCNT1=0

	TZ.TSTR.BYTE	=	0x03;	//TCNT0,1 JEgX^[g
}

/************************************************************************
	^C}Z `l0 
************************************************************************/
#pragma regsave (intprog_tmz0)
void intprog_tmz0(void)
{
	int i;

	//^C}Z I[ot[C^[vgtO NA
	TZ0.TSR.BIT.OVF =0;

	//TCNT0,1 ~
	TZ.TSTR.BYTE = 0x00;

	//JEgl̉Z
	if (SequenceStage==1){
		for (i=0; i<8; i++){
			ServoCnt[i] = ServoCnt[i] + Add1Step[i];
		}
		MoveCnt--; if (MoveCnt==0) {SequenceStage = 2;}
	}

	//^C}ZɃJEglZbg
	TZ0.GRA = ServoCnt[0] / 0x10000;
	TZ0.GRB = ServoCnt[1] / 0x10000;
	TZ0.GRC = ServoCnt[2] / 0x10000;
	TZ0.GRD = ServoCnt[3] / 0x10000;
	TZ1.GRA = ServoCnt[4] / 0x10000;
	TZ1.GRB = ServoCnt[5] / 0x10000;
	TZ1.GRC = ServoCnt[6] / 0x10000;
	TZ1.GRD = ServoCnt[7] / 0x10000;

	//o͂1ɂ
	TZ.TOCR.BYTE = 0xff;

	//TCNT0,1 JEgX^[g
	TZ0.TCNT = 0x0000;
	TZ1.TCNT = 0x0000;
	TZ.TSTR.BYTE = 0x03;
}

/************************************************************************
	RxBuf ̏
************************************************************************/
void init_rxbuf(void)
{
	RxBufRdPnt	=	RxBuf;				//Mobt@[h|C^Zbg
	RxBufWrPnt	=	RxBufRdPnt;			//Mobt@Cg|C^Zbg
	RxBufMin	=	RxBuf;				//Mobt@̍ŏZbg
	RxBufMax	=	RxBuf+RXBUF_SIZE-1;	//Mobt@̍ŌZbg
	RxCmdStage	=	0x00;
}

/************************************************************************
	RxBuf Ƀf[^i[
-------------------------------------------------------------------------
			data		RxBufɊi[f[^
-------------------------------------------------------------------------
	߂l	OK			i[ł
			NG			G[,obt@炠ӂꂽ
************************************************************************/
int put_rxbuf(unsigned char data)
{
	int ret_code;	//OK or NG

	if ((RxBufRdPnt==RxBufMin && RxBufWrPnt==RxBufMax) || RxBufWrPnt==RxBufRdPnt-1)
		ret_code = NG;		//obt@TCYz
	else{
		*RxBufWrPnt = data;
		RxBufWrPnt++;
		if (RxBufWrPnt>RxBufMax)
			RxBufWrPnt=RxBufMin;	//Cg|C^擪ɖ߂
		ret_code = OK;
	}
	return ret_code;
}

/************************************************************************
	RxBuf f[^o
-------------------------------------------------------------------------
			*pd			of[^Zbg|C^
-------------------------------------------------------------------------
	߂l	OK			o
			NG			G[,obt@ɉĂȂ
************************************************************************/
int get_rxbuf(unsigned char *pd)
{
	int ret_code;

	if (RxBufWrPnt==RxBufRdPnt)
		ret_code = NG;		//obt@ɉĂȂ
	else{
		*pd = *RxBufRdPnt;
		RxBufRdPnt++;
		if (RxBufRdPnt>RxBufMax)
			RxBufRdPnt=RxBufMin;	//[h|C^擪ɖ߂
		ret_code = OK;
	}
	return ret_code;
}

/************************************************************************
	SCI3 CjVCY
************************************************************************/
void init_sci3(void)
{
	char i;

	IO.PMR1.BYTE = IO.PMR1.BYTE | 0x02;

	SCI3.SCR3.BYTE	=	0x00;
	SCI3.SMR.BYTE	=	0x00;	//,8bit,NonParity,StopBit=1
//	SCI3.BRR		=	15;		//38400Baud
	SCI3.BRR		=	10;		//57600Baud
	for(i=10;i>0;i--){}			//_~[EFCg
	SCI3.SCR3.BYTE	=	0x70;	//MCl[u,MCl[u,M݃Cl[u
}

/************************************************************************
	SCI3 ݁iݗvɂĐU蕪j
************************************************************************/
#pragma regsave (intprog_sci3)
void intprog_sci3(void)
{
	if (SCI3.SSR.BIT.OER==1
	 || SCI3.SSR.BIT.FER==1
	 || SCI3.SSR.BIT.PER==1)		rxerr_sci3();	//MG[
	else if (SCI3.SSR.BIT.RDRF==1)	rxdata_sci3();	//M
//	else if (SCI3.SSR.BIT.TEND==1)	txend_sci3();	//MI
//	else if (SCI3.SSR.BIT.TDRE==1)	txdata_sci3();	//M
}

/************************************************************************
	SCI3 MG[
************************************************************************/
void rxerr_sci3(void)
{
	unsigned char dmy;

	SCI3.SSR.BYTE = SCI3.SSR.BYTE & 0x87;	//G[tONA
	dmy = SCI3.RDR;							//_~[[h
}

/************************************************************************
	SCI3 M
************************************************************************/
void rxdata_sci3(void)
{
	put_rxbuf(SCI3.RDR);	//f[^RxBufɃXgA
}

/************************************************************************
	1Mi|[Oj
-------------------------------------------------------------------------
		txdata		Mf[^
************************************************************************/
void txone(unsigned char txdata)
{
	while(SCI3.SSR.BIT.TDRE==0){}		//M\܂ő҂
	SCI3.TDR = txdata;
}

/************************************************************************
	1Mi|[Oj
-------------------------------------------------------------------------
	߂l	Mf[^
************************************************************************/
unsigned char rxone(void)
{
	while(SCI3.SSR.BIT.RDRF==0){}		//M܂ő҂
	return SCI3.RDR;
}

/************************************************************************
	EFCg(10ms)
************************************************************************/
void wait(void)
{
	unsigned long i;

	for (i=0;i<33333;i++){}
}

/************************************************************************
	I/O|[g CjVCY
************************************************************************/
void init_io(void)
{
	IO.PUCR1.BYTE	=	0x80;	//|[g1,P17vAbvI
	IO.PCR1			=	0x00;	//|[g1,P10-P17
}

/************************************************************************
	EEPROMf[^[h
************************************************************************/
void load_eeprom(void)
{
	unsigned char i,j;
	unsigned int sum;
	unsigned char d[2];
	unsigned char h[32];
	unsigned int tmpHomePos[SERVO_MAX_INDEX];
	unsigned int tmpServoMax[SERVO_MAX_INDEX];
	unsigned int tmpServoMin[SERVO_MAX_INDEX];
	unsigned int *p;


	if (EX_EEPR_FLAG!=0) {return;}

	for (i=0; i<SERVO_MAX_INDEX; i++){
		tmpHomePos[i] = HomePos[i];
		tmpServoMax[i] = ServoMax[i];
		tmpServoMin[i] = ServoMin[i];
	}

	//wb_[
	EX_EEPR_ADDR = 0;
	EX_SQDT_ADDR = h;
	EX_SQDT_SIZE = 32;
	EEPRSQRD();
	for (i=0; i<32; i++){
		if (h[i]!=EepromHeader[i]) {return;}
	}

	//T[{[^̒_
	EX_EEPR_ADDR = 32;
	EX_SQDT_ADDR = HomePos;
	EX_SQDT_SIZE = 16;
	EEPRSQRD();

	//T[{[^̍ől
	EX_EEPR_ADDR = 32+16;
	EX_SQDT_ADDR = ServoMax;
	EX_SQDT_SIZE = 16;
	EEPRSQRD();

	//T[{[^̍ŏl
	EX_EEPR_ADDR = 32+16+16;
	EX_SQDT_ADDR = ServoMin;
	EX_SQDT_SIZE = 16;
	EEPRSQRD();

	//L[t[
	EX_EEPR_ADDR = 32+16+16+16;
	EX_SQDT_ADDR = KeyFrame;
	EX_SQDT_SIZE = 400;
	EEPRSQRD();

	//L[t[̐
	EX_EEPR_ADDR = 32+16+16+16+400;
	EX_SQDT_ADDR = &NumKeyFrame;
	EX_SQDT_SIZE = 1;
	EEPRSQRD();

	//`FbNT̊mF
	EX_EEPR_ADDR = 32+16+16+16+400+1;
	EX_SQDT_ADDR = d;
	EX_SQDT_SIZE = 2;
	EEPRSQRD();
	sum = cal_check_sum();
	if (sum!=(d[0]*0x100 + d[1])){
		for (i=0; i<SERVO_MAX_INDEX; i++){
			HomePos[i] = tmpHomePos[i];
			ServoMax[i] = tmpServoMax[i];
			ServoMin[i] = tmpServoMin[i];
		}
		p = KeyFrame;
		for (i=0; i<200; i++){
			*p = 0;
			p++;
		}
	}
}

/************************************************************************
	EEPROMɃf[^Z[u
************************************************************************/
void save_eeprom(void)
{
	unsigned int sum;
	unsigned char d[2];

	if (EX_EEPR_FLAG!=0) {return;}

	//wb_[
	EX_EEPR_ADDR = 0;
	EX_SQDT_ADDR = EepromHeader;
	EX_SQDT_SIZE = 32;
	EEPRSQWR();

	//T[{[^̒_
	EX_EEPR_ADDR = 32;
	EX_SQDT_ADDR = HomePos;
	EX_SQDT_SIZE = 16;
	EEPRSQWR();

	//T[{[^̍ől
	EX_EEPR_ADDR = 32+16;
	EX_SQDT_ADDR = ServoMax;
	EX_SQDT_SIZE = 16;
	EEPRSQWR();

	//T[{[^̍ŏl
	EX_EEPR_ADDR = 32+16+16;
	EX_SQDT_ADDR = ServoMin;
	EX_SQDT_SIZE = 16;
	EEPRSQWR();

	//L[t[
	EX_EEPR_ADDR = 32+16+16+16;
	EX_SQDT_ADDR = KeyFrame;
	EX_SQDT_SIZE = 400;
	EEPRSQWR();

	//L[t[̐
	EX_EEPR_ADDR = 32+16+16+16+400;
	EX_SQDT_ADDR = &NumKeyFrame;
	EX_SQDT_SIZE = 1;
	EEPRSQWR();

	//`FbNT
	sum = cal_check_sum();
	d[0] = (unsigned char)(sum / 0x0100);
	d[1] = (unsigned char)(sum & 0x00ff);
	EX_EEPR_ADDR = 32+16+16+16+400+1;
	EX_SQDT_ADDR = d;
	EX_SQDT_SIZE = 2;
	EEPRSQWR();
}

/************************************************************************
	EEPROMobt@̃`FbNŤvZ
************************************************************************/
unsigned int cal_check_sum(void)
{
	unsigned char i,j,k;
	unsigned int sum;
	unsigned int *p;

	sum = 0;

	for (i=0; i<8; i++){
		sum = sum + HomePos[i];
	}

	for (i=0; i<8; i++){
		sum = sum + ServoMax[i];
	}

	for (i=0; i<8; i++){
		sum = sum + ServoMin[i];
	}

	p = KeyFrame;
	for (i=0; i<200; i++){
		sum = sum + *p;
		p++;
	}

	sum = sum + (unsigned int)NumKeyFrame;

	return sum;
}
